// DllInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DllInfo.h"
#include "DllInfoDlg.h"
#include "LibraryInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDllInfoDlg dialog

CDllInfoDlg::CDllInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDllInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDllInfoDlg)
	m_szDllName = _T("");
	m_szCompanyName = _T("");
	m_szCopyRight = _T("");
	m_szDescription = _T("");
	m_szFileOS = _T("");
	m_szFileType = _T("");
	m_szFileVersion = _T("");
	m_szInternalName = _T("");
	m_szOriginalName = _T("");
	m_szProductName = _T("");
	m_szProductVersion = _T("");
	m_szVersion = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDllInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDllInfoDlg)
	DDX_Control(pDX, IDC_VERSION_STATIC, m_VersionStatic);
	DDX_Control(pDX, IDC_PRODVER_STATIC, m_ProdVsnStatic);
	DDX_Control(pDX, IDC_PRODNAME_STATIC, m_ProdNameStatic);
	DDX_Control(pDX, IDC_ORIGNAME_STATIC, m_OrigNameStatic);
	DDX_Control(pDX, IDC_INTNAME_STATIC, m_InternalNameStatic);
	DDX_Control(pDX, IDC_FILEVER_STATIC, m_FileVsnStatic);
	DDX_Control(pDX, IDC_FILEOS_STATIC, m_FileOSStatic);
	DDX_Control(pDX, IDC_DESC_STATIC, m_DescriptionStatic);
	DDX_Control(pDX, IDC_COPYRIGHT_STATIC, m_CopyRightStatic);
	DDX_Control(pDX, IDC_COMPNAME_STATIC, m_CompNameStatic);
	DDX_Control(pDX, IDC_FILETYPE_STATIC, m_FileTypeStaic);
	DDX_Control(pDX, IDC_DLLNAME_EDIT, m_DllNameEdit);
	DDX_Text(pDX, IDC_DLLNAME_EDIT, m_szDllName);
	DDX_Text(pDX, IDC_COMPNAME_STATIC, m_szCompanyName);
	DDX_Text(pDX, IDC_COPYRIGHT_STATIC, m_szCopyRight);
	DDX_Text(pDX, IDC_DESC_STATIC, m_szDescription);
	DDX_Text(pDX, IDC_FILEOS_STATIC, m_szFileOS);
	DDX_Text(pDX, IDC_FILETYPE_STATIC, m_szFileType);
	DDX_Text(pDX, IDC_FILEVER_STATIC, m_szFileVersion);
	DDX_Text(pDX, IDC_INTNAME_STATIC, m_szInternalName);
	DDX_Text(pDX, IDC_ORIGNAME_STATIC, m_szOriginalName);
	DDX_Text(pDX, IDC_PRODNAME_STATIC, m_szProductName);
	DDX_Text(pDX, IDC_PRODVER_STATIC, m_szProductVersion);
	DDX_Text(pDX, IDC_VERSION_STATIC, m_szVersion);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDllInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CDllInfoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_DLLNAME_EDIT, OnChangeDllnameEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDllInfoDlg message handlers

BOOL CDllInfoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDllInfoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDllInfoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDllInfoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDllInfoDlg::OnChangeDllnameEdit() 
{
	 m_DllNameEdit.GetWindowText (m_szDllName);
}

void CDllInfoDlg::OnOK() 
{
	DLLINFO dllInfo;
	
	if (m_szDllName.IsEmpty ()) {
		AfxMessageBox (_T("No Dll/Exe name specified."), MB_ICONINFORMATION);
		return;
	}

	if (m_LibInfo.GetDllName () != m_szDllName) {

		m_LibInfo.SetDllName (m_szDllName);

		if (!m_LibInfo.GetDllInfo (dllInfo)) {
			AfxMessageBox (_T("Failed to get DLL information."), MB_ICONINFORMATION);
			return;
		}
		
		m_szFileOS = dllInfo.stFileOS;
		m_szFileType = dllInfo.stFileType;
		m_szFileVersion = dllInfo.stFileVersion;
		m_szCopyRight = dllInfo.stCopyRight;
		m_szDescription = dllInfo.stDescription;
		m_szInternalName = dllInfo.stInternalName;
		m_szOriginalName = dllInfo.stOriginalName;
		m_szProductName = dllInfo.stProductName;
		m_szProductVersion = dllInfo.stProductVersion;
		m_szVersion = dllInfo.stDllVersion;
		m_szCompanyName = dllInfo.stCompany;
	}

	UpdateData (FALSE);
	
}
